/* slicc.js
 * Stole this from Digitalbarrito as before, but this time it seems there's extra credit that needs to be given to:
 * Ereshkigal
 * Terkoiz
 * Byaukan
 * <3 love you guys for letting me steal your vibe here
 */

"use strict";

class SliccClass
{
    constructor()
    {
        core_f.packager.onLoad["Carl-SLICC"] = this.load.bind(this);
        common_f.logger.logInfo(`Loading: SLICC Case`)
    }

    load()
    {
        const modPath = core_f.packager.getModPath("Carl-SLICC");
        const db = common_f.json.deserialize(common_f.vfs.readFile(`${modPath}/db.json`));

        // Adding to item trunks
        let base = database_f.server.tables.templates.items;

        for (let file in base) {
            let fileData = base[file];
            if (fileData._id === "59fb042886f7746c5005a7b2" || fileData._id === "5c0a840b86f7742ffa4f2482") { //59fb042886f7746c5005a7b2 being the items case and 5c0a840b86f7742ffa4f2482 being the THICC case
                if (fileData._props.Grids[0]._props.filters !== undefined && fileData._props.Grids[0]._props.filters.length !== 0) {
                    fileData._props.Grids[0]._props.filters[0].Filter.push("container_slicc");
                }
            }
        }
        
        // Add items
        for (const itemKey in db.items)
        {
            const path = db.items[itemKey];
            const item = common_f.json.deserialize(common_f.vfs.readFile(`${modPath}/${path}`));
            database_f.server.tables.templates.items[item._id] = item;
        }

        // Add Handbook Entry
        for (const itemKey in db.templates.handbook)
        {
            const path = db.templates.handbook[itemKey];
            const item = common_f.json.deserialize(common_f.vfs.readFile(`${modPath}/${path}`));
            database_f.server.tables.templates.handbook.Items.push(item)
        }
        

        // Add locales
        for (const langKey in db.locales.en.templates)
        {
            const path = db.locales.en.templates[langKey];
            const lang = common_f.json.deserialize(common_f.vfs.readFile(`${modPath}/${path}`));
            database_f.server.tables.locales.global.en.templates[langKey] = lang;
        }

        // Add items to traders
        for (const itemKey in db.assort.ragfair.items)
        {
            const path = db.assort.ragfair.items[itemKey];
            const item = common_f.json.deserialize(common_f.vfs.readFile(`${modPath}/${path}`));
            database_f.server.tables.traders.ragfair.assort.items.push(item);
        }

        for (const itemKey in db.assort.ragfair.loyal_level_items)
        {
            const path = db.assort.ragfair.loyal_level_items[itemKey];
            const item = common_f.json.deserialize(common_f.vfs.readFile(`${modPath}/${path}`));
            database_f.server.tables.traders.ragfair.assort.loyal_level_items[itemKey] = item;
        }

        for (const itemKey in db.assort.ragfair.barter_scheme)
        {
            const path = db.assort.ragfair.barter_scheme[itemKey];
            const item = common_f.json.deserialize(common_f.vfs.readFile(`${modPath}/${path}`));
            database_f.server.tables.traders.ragfair.assort.barter_scheme[itemKey] = item;
        }
    }
} // why the fuck is itemKey never explicitly set to container_slicc? or does this just happen automatically for everything it finds in the database

module.exports.SLICC = SliccClass;

